<template>
  <details ref="component"
           class="rui-dropdown"
           :class="cssClasses"
           @mouseleave="close">
    <summary class="rui-button rui-dropdown__trigger -flex -gap" :class="triggerCssClasses" :title="noCaption ? caption : ''">
      <rui-icon v-if="icon" :name="icon" />
      <span v-if="!noCaption && (caption || $slots.caption)" class="rui-button__text">
        <slot name="caption">{{ caption }}</slot>
      </span>
      <rui-icon v-if="arrowIcon || noCaption" :name="arrowIcon || 'rui:more-dots'" class="rui-dropdown__trigger__icon" />
    </summary>
    <rui-menu class="rui-dropdown__content" @click="handleClickInside">
      <slot />
    </rui-menu>
  </details>
</template>

<script>
import RuiMenu from '../Menu/Menu.vue'
import RuiIcon from '../Icon/Icon.vue'
import { variants } from '../Button/Button.vue'

/**
 * Dropdown menu.
 *
 * It wraps a `RuiMenu`, so give it `RuiMenuItem`s.
 *
 * Dropdowns will auto-close when mouse leaves the Vue component; you will have to toggle its `open` property manually
 * when using HTML only.
 *
 * @preset Default {
 *                   "props": { "caption": "Click me" },
 *                   "slots": { "default": "<a class=\"rui-menu-item\" href=\"#\">Link</a>\n<button class=\"rui-menu-item\" href=\"#\">Button</a>" }
 *                 }
 * @preset No text on small screens {
 *                    "props": { "caption": "Click me", "noTextOnSmall": true },
 *                    "slots": { "default": "<a class=\"rui-menu-item\" href=\"#\">Link</a>\n<button class=\"rui-menu-item\" href=\"#\">Button</a>" }
 *                  }
 * @preset Custom arrow and no caption {
 *                     "props": { "caption": "More", "noCaption": true, "arrowIcon": "rui:more-dots" },
 *                     "slots": { "default": "<a class=\"rui-menu-item\" href=\"#\">Link</a>\n<button class=\"rui-menu-item\" href=\"#\">Button</a>" }
 *                   }
 * @preset Trigger variant, icon and arrow {
 *                     "props": { "caption": "More", "icon": "rui:help", "variant": "destructive", "arrowIcon": "rui:more-dots" },
 *                     "slots": { "default": "<a class=\"rui-menu-item\" href=\"#\">Link</a>\n<button class=\"rui-menu-item\" href=\"#\">Button</a>" }
 *                   }
 * @propsGroup Display  [block, right, wide, selectLike, noCaption, variant]
 * @propsGroup Behavior [noTextOnSmall]
 * @propsGroup Content  [caption, icon]
 */
export default {
  name: 'RuiDropdown',
  components: { RuiMenu, RuiIcon },
  props: {
    /** Trigger caption. Used as `title` attribute if `noCaption` flag is set */
    caption: { required: false, type: String, default: null },
    /** Optional icon */
    icon: { required: false, type: String, default: null },
    /** Custom icon name to use instead of the default one */
    arrowIcon: { required: false, type: String, default: null },
    /** Display trigger as block. Automatically applied when `selectLike` is used. */
    block: { required: false, type: Boolean, default: false },
    /** Align menu on the right */
    right: { required: false, type: Boolean, default: false },
    /** Display a wide menu */
    wide: { required: false, type: Boolean, default: false },
    /** Whether to display the trigger like a select input. Also activates `block` style */
    selectLike: { required: false, type: Boolean, default: false },
    /**
     * Trigger variant
     *
     * @values destructive, destructive-text, creative, creative-text, recording, recording-text, canceling, canceling-text, helping, helping-text, dim, dim-text
     */
    variant: { required: false, type: String, default: null, validator: (v) => variants.includes(v) },
    /**
     * Whether to only display an icon.
     * It will replace the default caret icon on the right and use the caption as title attribute on the trigger.
     * Do not use the `caption` slot with this option as it won't work.
     */
    noCaption: { required: false, type: Boolean, default: false },
    /**
     * Whether to hide text from trigger on small screens, leaving only the icon if any.
     * Works with both `caption` slot or prop
     */
    noTextOnSmall: { required: false, type: Boolean, default: false },
  },
  computed: {
    cssClasses () {
      return [
        (this.$props.block || this.$props.selectLike) && 'rui-dropdown--block',
        this.$props.right && 'rui-dropdown--right',
        this.$props.wide && 'rui-dropdown--wide',
        this.$props.selectLike && 'rui-dropdown--select-like',
        this.$props.noCaption && 'rui-dropdown--no-caption',
      ]
    },
    triggerCssClasses () {
      return [
        this.noTextOnSmall && 'rui-button--no-text-on-small',
        this.variant && `rui-button--${this.variant}`,
        this.arrowIcon && 'rui-dropdown__trigger--custom-arrow',
      ]
    },
  },
  methods: {
    open () {
      if (this.selectLike) return

      this.$refs.component.open = true
    },
    close () {
      if (this.selectLike) return

      this.$refs.component.open = false
    },
    handleClickOutside (event) {
      const component = this.$refs.component
      if (!component || !component.open) return

      let node = event.target
      while (node && node !== component) node = node?.parentNode

      if (node !== component) { component.open = false }
    },
    handleClickInside () {
      if (!this.$refs.component) return

      this.$refs.component.open = false
    },
  },
  mounted () {
    window.addEventListener('click', this.handleClickOutside)
  },
  unmounted () {
    window.removeEventListener('click', this.handleClickOutside)
  },
}
</script>
